package org.esupportail.portal.channels.gestion.CMonDossierWeb;

import java.io.IOException;
import org.esupportail.portal.utils.channels.ConfigChannel;
import org.jasig.portal.services.LogService;


/**
 * 
 * <p>ConfigChannel</p>
 * <p>Classe permettant d'accder  la configuration de la channel CAdresses</p>
 * (c)Copyright <a href="www.esup-portail.org">ESup-Portail 2004</a>
 * @author <a href="mailto:olivier.ziller@univ-nancy2.fr">Olivier Ziller</a>
 * @version 1.0
 *
 */
public class Config extends ConfigChannel
{ 
	//dclaration des variables de la classe
	private static Config singleton = null;
	//infos relatives  l'annuaire ldap
 	private String urlLdap;
	private String filtre;
	private String attLDAP;
	// info pour la partie adresse
	private String COD_ANU_INS;

	/**
	* 
	* @return ConfigChannel Instance
	* @throws IOException
	* @throws JspException
	*/
	public static Config getInstance() {
	if(singleton == null) {
		 singleton = new Config();
		 }
	return singleton;
	}

	/**
	 * Mthode qui permet d'ajouter une personnalisation sur les rgles que doit prendre en compte
	 * le digester
	 */
	protected void customDigester() {
		dig.addCallMethod("config","addRoot",4);
		dig.addCallParam("config/urlLDAP",0);
		dig.addCallParam("config/filtreLDAP",1);
		dig.addCallParam("config/attLDAP",2);
		dig.addCallParam("config/COD_ANU_INS",3);
	}

	/* (non-Javadoc)
	 * @see org.esupportail.portal.utils.channels.ConfigChannel#getConfigFile()
	 */
	protected String getConfigFile() {
		return "/properties/channels/org_esup/CMonDossierWeb/CMonDossierWeb.xml";
	}
	
	/**
	* 
	* @param server Parameter of file CMonDossierWeb.xml
	* @param port Parameter of file CMonDossierWeb.xml
	* @param baseURI Parameter of file CMonDossierWeb.xml
	* @param version Parameter of file CMonDossierWeb.xml
	* 
	*/
	public void addRoot(String url, String filtre, String attLDAP,String COD_ANU_INS){
		this.urlLdap = url;
		this.filtre = filtre;
		this.attLDAP = attLDAP;
		this.COD_ANU_INS = COD_ANU_INS;
	}
	/**
	 * @return
	 */
	public String getAttLDAP() {
		return attLDAP;
	}

	/**
	 * @return
	 */
	public String getFiltre() {
		return filtre;
	}

	/**
	 * @param string
	 */
	public void setAttLDAP(String string) {
		attLDAP = string;
	}

	/**
	 * @param string
	 */
	public void setFiltre(String string) {
		filtre = string;
	}

	/**
	 * @return
	 */
	public String getUrlLdap() {
		return urlLdap;
	}

	/**
	 * @param string
	 */
	public void setUrlLdap(String string) {
		urlLdap = string;
	}

	/**
	 * @return
	 */
	public String getCOD_ANU_INS() {
		return COD_ANU_INS;
	}

	/**
	 * @param string
	 */
	public void setCOD_ANU_INS(String string) {
		COD_ANU_INS = string;
	}

}

