package org.esupportail.portal.channels.gestion.CMonDossierWeb;

import java.sql.SQLException;

/*import javax.naming.NamingEnumeration;
import javax.naming.directory.SearchControls;*/

import org.jasig.portal.ChannelRuntimeData;
import org.jasig.portal.PortalException;
import org.jasig.portal.services.LogService;
import org.esupportail.portal.utils.channels.FrameWorkException;
import org.esupportail.portal.utils.channels.MainChannel;
import org.esupportail.portal.utils.channels.SubChannel;
import org.esupportail.portal.utils.database.Query;


/**
 * Inscription<br>
 * <br>
 * Gestion de l'affichage des inscriptions d'un tudiant <br>
 * <br>
 * (c)Copyright <a href="http://www.esup-portail.org">ESup-Portail 2004</a><br>
 * @author <a href="mailto:cedric.champmartin@univ-nancy2.fr">Cdric Champmartin</a>
 * @version 1.0
 * 
 */
public class Inscription extends SubChannel  {

	//Rmq : Les mthodes non documentes sont hrites de la classe SubChannel, et surcharges ici
	
	// Classe principale de la channel
	private CMonDossierWeb owner;
	//indique si la personne connecte a le droit de consulter l'action
 	//private boolean checkAcces = true;
 	// libell de l'anne consulte	
	private String lib_annee = new String();
	private String codETB;
	private String datDebInscr;
	private String etablissementDebut;
	private String xml;
	
	/**
	 * Contructeur de la classe
	 * @param main
	 */
	public Inscription(MainChannel main) {
		super(main);
		owner = (CMonDossierWeb)main;
	}

	/*
	public boolean canDisplay() {
		// Met les attributs LDAP  rcuprer dans un tableau de chaines
		String[] attrIDs = new String [1];
		attrIDs[0] = "objectclass";
		LDAPHandler LDAP = new LDAPHandler();
		LDAP.setUrl(Config.getInstance().getUrlLdap());
		LDAP.setAttributes(attrIDs);
		LDAP.setMaxEntries(0); // pas de limitation de rsultat
		LDAP.setBase("ou=people");
		LogService.log(LogService.INFO ,"filtre ldap : " + Config.getInstance().getFiltre());
		LogService.log(LogService.INFO ,"uid : " + owner.getUserId());
		LDAP.setFilter("(&("+Config.getInstance().getFiltre()+")(uid="+owner.getUserId()+"))");
		LDAP.setScope(SearchControls.SUBTREE_SCOPE);
		NamingEnumeration answer = LDAP.search();
		// Parcours les rponses
		try {
			if (answer!=null) {
				if (answer.hasMore())
					return true;
			}		
		}
		catch (javax.naming.NamingException e) {
			LogService.log(LogService.ERROR ,"Inscription::canDisplay() : Erreur LDAP " + e);
		}
		finally {
			LDAP.close();
		}
		return false;	
	}
*/
	
	public Boolean setXML() throws FrameWorkException {
				
		if (xml == null) {
			xml = START_XML;
			xml += owner.getXmlEtudiant();
			// on rcupre les infos sur la premire inscription
			premiereInscription();
			xml += "<inscriptions anneeDebut=\"";
			if (this.datDebInscr == null)
				xml+= "";
			else
				xml += this.datDebInscr;	 
			xml += "\" etablissementDebut=\"";
			if (this.etablissementDebut == null)
				xml += "";
			else
				xml += this.etablissementDebut;
			xml += "\">";
			xml += getXmlInscriptionIAE();
			xml += getXmlInscriptionDAC();
			xml += "</inscriptions>";
			xml += END_XML;
		}
		setXML(xml);
		// passage de paramtre  la feuille de style xsl
		this.getXSLParameter().put("libAnnee", lib_annee.toLowerCase());
				
		return Boolean.TRUE;
	}
	
	public Boolean init(ChannelRuntimeData rd) throws PortalException, FrameWorkException {
		Boolean res = super.init(rd);
		/*if (!canDisplay() && checkAcces != false){
			checkAcces = false;
			// on ne redirige que si la personne n'est pas dj sur la page d'interdiction
			owner.redirect(rd,"interdit");	
		}*/
		return res;	
	}
	
	/**
	 * Mthode qui fixe l'tablissement 1re inscription
	 * 
	 */
	public void premiereInscription() throws FrameWorkException {
		Query qry = null;
		boolean error = false;
		
		try {
			qry = Config.getInstance().getConnexionDefault();
			qry.setSql("select i.daa_ent_etb, i.cod_etb " +
					   "from apogee.individu i " +
					   "where i.cod_ind= ? ");
			qry.getStmt().setString(1, owner.getCodInd());
			qry.select();
			while (qry.getRs().next()){
				this.datDebInscr = qry.getRs().getString("daa_ent_etb");
				this.codETB = qry.getRs().getString("cod_etb");	
			}
			qry.setSql("select LIB_ETB from apogee.etablissement where cod_etb = ?");
			qry.getStmt().setString(1, this.codETB);				
			qry.select();
			while (qry.getRs().next()){
				this.etablissementDebut = qry.getRs().getString("LIB_ETB");	
			}
		}
		catch (SQLException e) {
			LogService.log(LogService.ERROR ,"Inscription::premiereInscription() : Erreur SQL " + e);
			error = true;
		}
		finally {
			qry.close();
			if (error)
				throw new FrameWorkException();
		}		
	}
	
	
	/**
	 * Mthode qui retourne les inscriptions d'un tudiant sous forme d'un flux xml 
	 * 
	 */
	public String getXmlInscriptionIAE() throws FrameWorkException {
		String res = null;
		Query qry = null;
		boolean error = false;
		
		if (owner.getCodInd() != null) { // la personne connecte  un cod_ind
			try {
				qry = Config.getInstance().getConnexionDefault();
				qry.setSql("select iae.cod_anu||'/'||to_char(to_number(iae.cod_anu)+1) \"COD_ANU\"," +
   						   "iae.cod_etp, iae.cod_vrs_vet, e.lib_etp, iae.cod_ind " +
   						   "from apogee.ins_adm_etp iae, apogee.etape e " +
   						   "where iae.cod_ind = ? and iae.eta_iae = 'E' and e.cod_etp = iae.cod_etp " +
   						   "order by cod_anu desc,iae.cod_etp");
				qry.getStmt().setString(1, owner.getCodInd());				
				qry.select();			   
				while (qry.getRs().next()){
					res += "<inscription id =\"IAE\">" +
							 "<annee>"+qry.getRs().getString("COD_ANU")+"</annee>" +
							 "<code>"+qry.getRs().getString("cod_etp")+"</code>" +
							 "<vers>"+qry.getRs().getString("cod_vrs_vet")+"</vers>" +
							 "<etape>"+qry.getRs().getString("lib_etp")+"</etape>" +
							 "</inscription>";
				}
			}
			catch (SQLException e) {
				LogService.log(LogService.ERROR ,"Inscription::getXmlInscriptionIAE() : Erreur SQL " + e);
				error = true;
				
			}
			finally {
				qry.close();
				if (error)
					throw new FrameWorkException();
			}
		} 
		
		return res;
	
	}
	
	/**
	 * Mthode qui retourne les inscriptions d'un tudiant sous forme d'un flux xml 
	 * 
	 */
	public String getXmlInscriptionDAC() throws FrameWorkException {
		String res = null;
		Query qry = null;
		res = new String();
		boolean error = false;
		
		if (owner.getCodInd() != null) { // la personne connecte  un cod_ind
			try {
				qry = Config.getInstance().getConnexionDefault();
				qry.setSql("select d.daa_uni_dac||'/'||to_char(to_number(d.daa_uni_dac)+1) \"COD_ANU\"," +
   							"d.cod_dac,d.lib_cmt_dac,e.lib_etb,decode(d.tem_obt_dac,'N','AJOURNE','OBTENU') \"RES\" " +
   							"from apogee.ind_dac d, apogee.etablissement e " +
   							"where d.cod_ind = ? and e.cod_etb = d.cod_etb and e.cod_tpe = d.cod_tpe " +
   							"order by d.daa_uni_dac desc");
				qry.getStmt().setString(1, owner.getCodInd());				
				qry.select();			   
				while (qry.getRs().next()){
					res += "<inscription id =\"DAC\">" +
							 "<annee>"+qry.getRs().getString("COD_ANU")+"</annee>" +
							 "<type>"+qry.getRs().getString("cod_dac")+"</type>" +
							 "<specialite>"+qry.getRs().getString("lib_cmt_dac")+"</specialite>" +
							 "<etablissement>"+qry.getRs().getString("lib_etb")+"</etablissement>" +
							 "<resultat>"+qry.getRs().getString("RES")+"</resultat>" +
							 "</inscription>";
				}
			}
			catch (SQLException e) {
				LogService.log(LogService.ERROR ,"Inscription::getXmlInscriptionDAC() : Erreur SQL " + e);
				error = true;
			}
			finally {
				qry.close();
				if (error)
					throw new FrameWorkException();	
			}
		} 
		
		return res;

	}

}
