<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
   <xsl:import href="genEtudiant.xsl" />
   <xsl:import href="Liens.xsl"/>
   <xsl:import href="CodesRes.xsl"/>
   <xsl:output method="html" indent="no" />

   <xsl:param name="baseActionURL">baseActionURL_false</xsl:param>

   <xsl:param name="prefForm" />

   <xsl:template match="/">
   	  <xsl:call-template name="liens"/>	
      <div class="uportal-background-dark">
         <P ALIGN="CENTER" class="uportal-text-reversed"><br/><b>R E S U L T A T S</b><br/><br/></P>
      </div>

      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
         <TR>
            <TD WIDTH="100%" HEIGHT="40" class="uportal-background-light">
               <P ALIGN="CENTER" class="uportal-channel-strong">
                  E T U D I A N T
               </P>
            </TD>
         </TR>
      </TABLE>

      <xsl:call-template name="genEtudiant">
         <xsl:with-param name="dossier" select="xml/etudiant/dossier" />

         <xsl:with-param name="NNE" select="xml/etudiant/NNE" />

         <xsl:with-param name="nom" select="xml/etudiant/nom" />

         <xsl:with-param name="prenom" select="xml/etudiant/prenom" />

         <xsl:with-param name="email" select="xml/etudiant/email" />
      </xsl:call-template>

      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
         <TR>
            <TD WIDTH="100%" HEIGHT="40" class="uportal-background-light">
               <P ALIGN="CENTER" class="uportal-channel-strong">
                  D I P L O M E S
               </P>
            </TD>
         </TR>
      </TABLE>

      <TABLE BORDER="0" CELLPADDING="2" CELLSPACING="0" WIDTH="100%">
         <tr>
            <td width="10%" class="uportal-channel-strong">
               Année

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>

            <td width="15%" class="uportal-channel-strong">
               Code / Vers.

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>

            <td width="30%" class="uportal-channel-strong">
               Diplôme

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>

            <td width="16%" colspan="2" class="uportal-channel-strong">
               Session

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>

            <td width="8%" class="uportal-channel-strong">
               Note

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>

            <td width="8%" class="uportal-channel-strong">
               Résultat

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>
         </tr>

         <xsl:for-each select="xml/diplome">
         <tr onMouseOver="javascript:this.className='uportal-background-highlight'" onMouseOut="javascript:this.className='uportal-background-content'">
         	<td colspan="7">
         	<table border="0" width="100%" CELLPADDING="0" CELLSPACING="0">
            <tr>
               <td class="uportal-text" WIDTH="11%">
                  <xsl:value-of select="@annee" />
               </td>

               <td class="uportal-text" WIDTH="18%">
                  <xsl:value-of select="@code" />
               </td>

               <td class="uportal-text" WIDTH="34%">
                  <xsl:value-of select="@libelle" />
               </td>
            </tr>

            <xsl:for-each select="session">
               <xsl:call-template name="session" />
            </xsl:for-each>
           </table>
         </td>
         </tr>   
         </xsl:for-each>
      </TABLE>

      <TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" WIDTH="100%">
         <TR>
            <TD WIDTH="100%" HEIGHT="40" class="uportal-background-light">
               <P ALIGN="CENTER" class="uportal-channel-strong">
                     E T A P E S
               </P>
            </TD>
         </TR>
      </TABLE>

      <TABLE BORDER="0" CELLPADDING="2" CELLSPACING="0" WIDTH="100%">
         <TR>
            <TD WIDTH="10%" class="uportal-channel-strong">
               Année

               <HR ALIGN="CENTER" SIZE="1" NOSHADE="NSOSHADE" />
            </TD>

            <TD WIDTH="15%" class="uportal-channel-strong">
               Code / Vers.

               <HR ALIGN="CENTER" SIZE="1" NOSHADE="NSOSHADE" />
            </TD>

            <TD WIDTH="30%" class="uportal-channel-strong">
               Etape

               <HR ALIGN="CENTER" SIZE="1" NOSHADE="NSOSHADE" />
            </TD>

            <TD WIDTH="16%" colspan="2" class="uportal-channel-strong">
               Session

               <HR ALIGN="CENTER" SIZE="1" NOSHADE="NSOSHADE" />
            </TD>

            <TD WIDTH="8%" class="uportal-channel-strong">
               Note

               <HR ALIGN="CENTER" SIZE="1" NOSHADE="NSOSHADE" />
            </TD>

            <td WIDTH="8%" class="uportal-channel-strong">
               Résultat

               <hr align="CENTER" size="1" NOSHADE="NSOSHADE" />
            </td>
         </TR>

         <xsl:for-each select="xml/etape">
         	<tr onMouseOver="javascript:this.className='uportal-background-highlight'" onMouseOut="javascript:this.className='uportal-background-content'">
         	<td colspan="7">
         	<table border="0" width="100%" CELLPADDING="0" CELLSPACING="0">
            <tr>
               <td class="uportal-text"  WIDTH="11%">
                  <xsl:value-of select="@annee" />
               </td>

               <td class="uportal-text" WIDTH="18%">
                  <xsl:choose>
                     <xsl:when test="local-name(.) = 'etape'">
                        <a href="{$baseActionURL}?action=detailNotes&amp;code={@code}&amp;codeAnnu={@codeAnnu}">
                           <xsl:value-of select="@code" />
                        </a>
                     </xsl:when>

                     <xsl:otherwise>
                        <xsl:value-of select="@code" />
                     </xsl:otherwise>
                  </xsl:choose>
               </td>

               <td class="uportal-text" WIDTH="34%">
               <xsl:choose>
                  <xsl:when test="local-name(.) = 'etape'">
               	  <a href="{$baseActionURL}?action=detailNotes&amp;code={@code}&amp;codeAnnu={@codeAnnu}">
                  <xsl:value-of select="@libelle" />
                  </a>
                </xsl:when>
                <xsl:otherwise>
					<xsl:value-of select="@libelle" />
                </xsl:otherwise>
               </xsl:choose>  
               </td>
               <td colspan="3">
               &#160;
               </td>
            </tr>

            <xsl:for-each select="session">
               <xsl:call-template name="session" />
            </xsl:for-each>
            </table>
         </td>
         </tr>
         </xsl:for-each>
      </TABLE>
	  <xsl:call-template name="codesRes"/>	
      <form name="{$prefForm}MonDossierWeb" action="{$baseActionURL}" method="post">
         <input type="hidden" value="default" name="action" />

         <center>
            <input type="submit" value="Retour" name="retour" class="uportal-button"/>
         </center>
      </form>
   </xsl:template>

   <xsl:template name="session">
      <xsl:if test="(@note != 'null' and @note != ' ') or (@resultat != ' ' and @resultat != 'null')">
         <tr>
            <td class="uportal-text" colspan="3">
               &#160;
            </td>

            <td class="uportal-text" WIDTH="19%">
               <xsl:value-of select="@type" />
            </td>         

            <td class="uportal-text" WIDTH="9%">
               <xsl:if test="@note != 'null'">
                  <xsl:value-of select="@note" />
               </xsl:if>
            </td>

            <td class="uportal-text">
               <xsl:if test="@resultat != 'null'">
                  <xsl:value-of select="@resultat" />
               </xsl:if>
            </td>
         </tr>
      </xsl:if>
   </xsl:template>
</xsl:stylesheet>

